

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="./">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.bilby_custom_FD_source_models package &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="_static/css/theme.css?v=7ab3649f" />

  
      <script src="_static/jquery.js?v=5d32c60e"></script>
      <script src="_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="_static/documentation_options.js?v=8d563738"></script>
      <script src="_static/doctools.js?v=9a2dae69"></script>
      <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="gwmat.methods package" href="gwmat.methods.html" />
    <link rel="prev" title="gwmat package" href="gwmat.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="gwmat.html">gwmat package</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="gwmat.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">gwmat.bilby_custom_FD_source_models package</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#submodules">Submodules</a></li>
<li class="toctree-l4"><a class="reference internal" href="#gwmat-bilby-custom-fd-source-models-eccentric-microlensed-bbh-source-module">gwmat.bilby_custom_FD_source_models.eccentric_microlensed_BBH_source module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-gwmat.bilby_custom_FD_source_models.microlensing_source">gwmat.bilby_custom_FD_source_models.microlensing_source module</a></li>
<li class="toctree-l4"><a class="reference internal" href="#module-gwmat.bilby_custom_FD_source_models">Module contents</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="gwmat.methods.html">gwmat.methods package</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#submodules">Submodules</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.constants">gwmat.constants module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.conversion">gwmat.conversion module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.cosmology">gwmat.cosmology module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.cythonized_point_lens">gwmat.cythonized_point_lens module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.domain">gwmat.domain module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.general_utils">gwmat.general_utils module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.gw_utils">gwmat.gw_utils module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.injection">gwmat.injection module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.nr_injection">gwmat.nr_injection module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat.point_lens">gwmat.point_lens module</a></li>
<li class="toctree-l2"><a class="reference internal" href="gwmat.html#module-gwmat">Module contents</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="gwmat.html">gwmat package</a></li>
      <li class="breadcrumb-item active">gwmat.bilby_custom_FD_source_models package</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/gwmat.bilby_custom_FD_source_models.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="gwmat-bilby-custom-fd-source-models-package">
<h1>gwmat.bilby_custom_FD_source_models package<a class="headerlink" href="#gwmat-bilby-custom-fd-source-models-package" title="Link to this heading"></a></h1>
<section id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Link to this heading"></a></h2>
</section>
<section id="gwmat-bilby-custom-fd-source-models-eccentric-microlensed-bbh-source-module">
<h2>gwmat.bilby_custom_FD_source_models.eccentric_microlensed_BBH_source module<a class="headerlink" href="#gwmat-bilby-custom-fd-source-models-eccentric-microlensed-bbh-source-module" title="Link to this heading"></a></h2>
</section>
<section id="module-gwmat.bilby_custom_FD_source_models.microlensing_source">
<span id="gwmat-bilby-custom-fd-source-models-microlensing-source-module"></span><h2>gwmat.bilby_custom_FD_source_models.microlensing_source module<a class="headerlink" href="#module-gwmat.bilby_custom_FD_source_models.microlensing_source" title="Link to this heading"></a></h2>
<p>Author: Anuj Mishra</p>
<p>This module contains a Bilby source file designed for
performing parameter estimation under the assumption
of an isolated point lens model.</p>
<p><strong>Methodology for Efficient Lensing Amplification Factor Computation</strong> :</p>
<p>1. <strong>Precompute the Wave Optics Part</strong>: A lookup table is generated to
precompute the “wave optics” contribution.</p>
<p>2. <strong>Geometrical Optics with Cython</strong>: Cython is employed to compute
the “geometrical optics” part efficiently using the power of C.</p>
<p>3. <strong>Dynamic Frequency Cutoff</strong>: A frequency cutoff, dependent on the
impact parameter, shifts the computation from wave to geometrical optics.
This cutoff is based on a numerical fit to ensure that the relative error
between the analytic ( F(f) ) and the geometrical optics approximation
is less than 1% for frequencies above the cutoff.</p>
<p><strong>Lookup Table</strong> :
The lookup table must be generated before using the source function. A script to generate the table is available at <cite>‘gwmat/scripts/generate_point_lens_Ff_lookup_table.py’</cite>. Once generated, the table can be provided to the sampler via the <cite>“lookup_table_path”</cite> keyword argument in <a href="#id1"><span class="problematic" id="id2">**</span></a>kwargs.</p>
<p><strong>Handling Lens Mass</strong> :
The <cite>point_lens_Ff_lookup_table</cite> function, which uses the lookup table, can handle any lens mass, provided it falls within the impact parameter range used when building the table. Typically, a lens mass range of ( (10^{-1}, 10^5) ) is sufficient for most use cases.</p>
<p><strong>Non-Lookup Table Version</strong> :
This module also includes a source model that does not rely on the lookup table, though it is slower due to the absence of precomputed values.</p>
<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.y_w_grid_data">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">y_w_grid_data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Ff_grid</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#y_w_grid_data"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.y_w_grid_data" title="Link to this definition"></a></dt>
<dd></dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.y_index">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">y_index</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">yl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ys_grid</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#y_index"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.y_index" title="Link to this definition"></a></dt>
<dd></dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.w_index">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">w_index</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">w</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ws_grid</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#w_index"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.w_index" title="Link to this definition"></a></dt>
<dd></dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_Ff_lookup_table">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">point_lens_Ff_lookup_table</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Mlz</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Ff_grid</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ys_grid</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ws_grid</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">extrapolate</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#point_lens_Ff_lookup_table"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_Ff_lookup_table" title="Link to this definition"></a></dt>
<dd></dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.load_lookup_table">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">load_lookup_table</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">lookup_table_path</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#load_lookup_table"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.load_lookup_table" title="Link to this definition"></a></dt>
<dd></dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">point_lens_microlensing_binary_black_hole</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">frequency_array</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">luminosity_distance</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">a_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tilt_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phi_12</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">a_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tilt_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phi_jl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">theta_jn</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phase</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Log_Mlz</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yl</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#point_lens_microlensing_binary_black_hole"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole" title="Link to this definition"></a></dt>
<dd><p>This is a Bilby Frequency Domain Source model for
performing parameter estimations assuming
isolated point lens model.</p>
<p>It returns microlensed frequency-domain plus and cross
polarized waveforms evaluated at the required
frequency_array.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>frequency_array</strong> (<em>*</em>) – Array of frequency values where the WF will be evaluated.</p></li>
<li><p><strong>mass_1</strong> (<em>*</em>) – The mass of the primary component object
in the binary (in solar masses).</p></li>
<li><p><strong>mass_2</strong> (<em>*</em>) – The mass of the secondary component object in
the binary (in solar masses).</p></li>
<li><p><strong>a_1</strong> (<em>*</em>) – The dimensionless spin magnitude of object 1.</p></li>
<li><p><strong>a_2</strong> (<em>*</em>) – The dimensionless spin magnitude of object 2.</p></li>
<li><p><strong>tilt_1</strong> (<em>*</em>) – Angle between L and the spin magnitude of object 1.</p></li>
<li><p><strong>tilt_2</strong> (<em>*</em>) – Angle between L and the spin magnitude of object 2.</p></li>
<li><p><strong>phi_12</strong> (<em>*</em>) – Difference between the azimuthal angles of
the spin of the object 1 and 2.</p></li>
<li><p><strong>phi_jl</strong> (<em>*</em>) – Azimuthal angle of L on its cone about J.</p></li>
<li><p><strong>Log_Mlz</strong> (<em>*</em>) – Redshifted Mass of the point-lens in
log10 scale (in solar masses).</p></li>
<li><p><strong>yl</strong> (<em>*</em>) – The dimensionless impact parameter between
the lens and the source.</p></li>
<li><p><strong>theta_jn</strong> (<em>*</em>) – Angle between the line of sight and
the total angular momentum J.</p></li>
<li><p><strong>luminosity_distance</strong> (<em>*</em>) – Luminosity distance to the binary (in Mpc).</p></li>
<li><p><strong>theta_jn</strong> – Inclination (rad), defined as the angle between
the orbital angular momentum J(or, L) and the
line-of-sight at the reference frequency.
Default = 0.</p></li>
<li><p><strong>phase</strong> (<em>*</em>) – Coalesence phase of the binary (in rad).</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p><ul class="simple">
<li><dl class="simple">
<dt>plus: A numpy array.</dt><dd><p>Strain values of the plus polarized WF in Frequency Domain..</p>
</dd>
</dl>
</li>
<li><dl class="simple">
<dt>cross: A numpy array.</dt><dd><p>Strain values of the cross polarized WF in Frequency Domain.</p>
</dd>
</dl>
</li>
</ul>
</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Dictionary</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole_analytic">
<span class="sig-prename descclassname"><span class="pre">gwmat.bilby_custom_FD_source_models.microlensing_source.</span></span><span class="sig-name descname"><span class="pre">point_lens_microlensing_binary_black_hole_analytic</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">frequency_array</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">luminosity_distance</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">a_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tilt_1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phi_12</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">a_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tilt_2</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phi_jl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">theta_jn</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">phase</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Log_Mlz</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yl</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/gwmat/bilby_custom_FD_source_models/microlensing_source.html#point_lens_microlensing_binary_black_hole_analytic"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole_analytic" title="Link to this definition"></a></dt>
<dd><p>This is similar to above source model
“point_lens_microlensing_binary_black_hole” but uses
analytic function to compute the wave optics part and
doesn’t require a lookup table.
This is more accurate but slower,
hence not recommended for doing an extensive PE.</p>
</dd></dl>

</section>
<section id="module-gwmat.bilby_custom_FD_source_models">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-gwmat.bilby_custom_FD_source_models" title="Link to this heading"></a></h2>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="gwmat.html" class="btn btn-neutral float-left" title="gwmat package" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="gwmat.methods.html" class="btn btn-neutral float-right" title="gwmat.methods package" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>